/* yasep/gui-js/dragndrop.js
  created sam. mai  5 21:30:27 CEST 2012 by whygee@f-cpu.org
  reuses stuff from the old tools/listed.js created 2009-01-23 by yg@yasep.org
Handles the "trash bin" and moving objects around ygwm windows
*/

init_obj.push(dragndrop={
  dragdropstate : 0, // state of the drag&drop operation
  //  0: nothing,
  //  1: move a standard block
  //  2: move an input port
  //  3: move an output port
  //  4: move a graph row
  //  5: move a whole graph

  destination:null,
  selected:null,

/////////////////////////////////////////////////
  happy:[
    ["hi! I was fading away...", "ah, at last.", "time to eat :-)", "cool, my turn!",
     "ooh, fill that void.", "hmmm hungry...", "yay! food!", "I'm starving",
     "thanks for thinking about me!", "feed me!", "i can has block"],
    ["salut&nbsp;!", "coucou :-D","ah, j'ai faim.", "bon, à table&nbsp;!", "je peux&nbsp;?",
     "justement, j'ai une petite faim.", "On m'appelle&nbsp;?", "c'est pour moi&nbsp;?",
     "hep&nbsp;! par là&nbsp;!", "il reste de la place ici", "petit petit", "viens par là toi...",
     "oooooh ça a l'air appétissant&nbsp;!", "i can has block", "poubelle, à votre service."]
  ],
  ready:[
    ["alright", "there, I'm ready", "what are you waiting for?", "yay! do it!",
     "drop it, drop it!", "ok, now depress that mouse button", "almost there...",
     "it's mine! miiine! hahaha!"],
    ["aaaah", "vas-y","on y est presque", "bon, tu attends quoi?", "chouette&nbsp;?!",
      "allez, donne", "un bloc pour papa...", "bon, maintenant tu relâches ce bouton.",
      "Il est à moi maintenant !", "il ne peut plus m'échapper..."]
  ],
  sad:[
    ["nothing for me ?", "are you sure ?", "please!", "ohhh...",
     "hey come back here", "I feel empty...", "why you starve me?",
     "maybe next time?", "hey i'm hungry!", "bye :-(", "so sad..." ],
    ["hé&nbsp;! reviens là&nbsp;!", "mais j'ai faim :-(", "pourquoi tu t'en vas&nbsp;?",
     "je suis au régime, c'est ça&nbsp;?", "bon, à la prochaine fois...", "radin.", "bon ben ciao",
     "c'était pourtant bien parti :-(", "ben alors&nbsp;?", "allez quoi", "zyva genre"]
  ],
  repu:[
    ["ahhh goood...", "yum yum!", "moaaarh...", "sweet!", "delicious ;-)",
     "thanks :-)", "*blurps*", "*crunch*", "yay! again!", "*brooops*", "thxbai!", "omnomnomnom"],
    ["ahhh ça fait du bien&nbsp;!", "miam, miam&nbsp;!", "il était temps", "on r'met ça&nbsp;?", "*blurps*",
     "hmm j'adore", "encore&nbsp;!", "j'en reprendrais bien un petit...", "c'est bon :-)",
     "délicieux&nbsp;!", "omnomnomnom", "*scrountch*"]
  ],

  happy_messages:true,
  trash_message_delay:null,

  trash_message_erase: function(msg){
    dragndrop.message_id.innerHTML="&nbsp;";
    // hide if d&d is finished, but leave enough time to read the message
    if(dragndrop.dragdropstate==0)
      dragndrop.trash_div_id.style.display="none";
    dragndrop.trash_message_delay=null;
  },

  trash_message: function(msg){
    clearTimeout(dragndrop.trash_message_delay);
    if (dragndrop.happy_messages) {
      var l=LANG.LANG,m=dragndrop[msg];
      if (!m[l])
        l=0;
      m=m[l];
      dragndrop.message_id.innerHTML=m[intrnd(m.length)];
    }
    dragndrop.trash_message_delay=setTimeout(dragndrop.trash_message_erase,3000);    
  },

/////////////////////////////////////////////////

/*
  transport_div:null,
  message_id:null,
*/
////////////////////////////////////////////////////
// Trash image animation
/*trash_image_id:null,
  trash_div_id:null,
  trash_frame_id:null, */
  trash_open:false,

//  trash_open_conditions:new Array,

  trash_mouseover:function() {
    if (dragndrop.dragdropstate > 0){ // drag&drop ?
      dragndrop.trash_message("ready");
      dragndrop.trash_image_id.style.right="48px";
      dragndrop.trash_open=true;
    }
    return true;
  },

  trash_mouseout:function() { // called by end_move too
    dragndrop.trash_message("sad");
    if (dragndrop.trash_open) {
      dragndrop.trash_image_id.style.right="0px";
      dragndrop.trash_open=false;
      if (!dragndrop.dragdropstate)
        dragndrop.trash_message("repu");
    }
    return false;
  },


/*
// When the mouse goes over a TR :
capture_mouseover_TR:function(ev) {
  var parent=this.parentNode;
  
  if ((dragndrop.dragdropstate > 0) && (this != dragndrop.moved_item)
     // If we're moving a TR in the same type of table, it's our event :
    && (parent.update_row_hooks == dragndrop.moved_row_parent.update_row_hooks)) {

    var newIndex=this;
    // move a row within the same table ?
    if (parent == dragndrop.moved_row_parent) {
      // evaluate where it's better to put the row...
      if ((this.TrLineNr > dragndrop.moved_row_prev_index)
      || ((this.TrLineNr == dragndrop.moved_row_prev_index)
           &&(this.previousSibling==dragndrop.moved_item)))
        newIndex=this.nextSibling;
    }
    // move from another table
    else {
      // focus
      ygwm.focus_window(null,ygwm.getParent(this));
    }
    dragndrop.moved_item=dragndrop.moved_row_parent.removeChild(dragndrop.moved_row);
    dragndrop.moved_item=parent.insertBefore(dragndrop.moved_item,newIndex);
    dragndrop.item_moved=true; // force renumbering on onmouseup
    dragndrop.moved_row_prev_index = this.TrLineNr;
    dragndrop.moved_row_parent=parent;
    return false;
  }
  return true;
},

// onmouseup :
mouse_drop_row:function(ev) {
// local copy
  moved_row=dragndrop.moved_row;
// if erased :
  if (dragndrop.trash_open==true) { // trash_open is set whenever the erase conditions are satisfied.
    dragndrop.moved_row_parent.removeChild(moved_row);
    // original point of view in original table :
    if (dragndrop.moved_row_prevSibling.nextSibling) // Is it the last element of the table ?
      dragndrop.renumber_lines(dragndrop.moved_row_prevSibling.nextSibling, moved_row.TrLineNr);
    else
      dragndrop.moved_row_original_parent.nbElements--; // update the element count.
    //  update the cached values and tables, and call a callback in the parent ?
    dragndrop.shortmsg(dragndrop.moved_row_root,"yum yum !");    
    dragndrop.trash_mouseout();
  }

  else {
    if ((dragndrop.item_moved==false) // If nothing has really moved
        || (moved_row.previousSibling == dragndrop.moved_row_prevSibling)) {
      // restore the style
      moved_row.className=dragndropd.OddEvenArray[moved_row.TrLineNr & 1];
    }
    // MOVED ROW ? then reorder them
    else {
      dragndrop.item_moved=false;
      if (dragndrop.moved_row_prevSibling.nextSibling) // Is it the last element of the table ?
        dragndrop.renumber_lines(dragndrop.moved_row_prevSibling.nextSibling, moved_row.TrLineNr);
      else
        dragndrop.moved_row_original_parent.nbElements--; // only update the element count.

      moved_row.TrLineNr=-2; // force the restoration of the style in some cases.
      var t=moved_row.previousSibling.TrLineNr; // first row ?
      if(typeof t=="number") 
        t++;
      else
        t=0;
      dragndrop.renumber_lines(moved_row,t);
    }
  }

  dragndrop.dragdropstate = 0;
  document.onmouseup=null;
  document.onmousemove=null;
  document.body.style.cursor='auto';
  return false;
},

/// onmousedown :
start_move_row:function(ev) {
// anti-window-manager-hickup :
  if (document.onmouseup!=null)
    document.onmouseup(ev);

  // get the selected TR's id
  // dragndrop.getParent(this); ??
  var moved_row=this;
  while (moved_row.nodeName != "TR") {
    moved_row=moved_row.parentNode;
    if (moved_row==null)
      return false;
  }
  dragndrop.moved_row = moved_row; // local copies
  var moved_row_parent=moved_row.parentNode;
  dragndrop.moved_row_parent=moved_row_parent;
  dragndrop.moved_row_original_parent=moved_row_parent;
  dragndrop.moved_row_root=dragndrop.getParent(moved_row_parent);
  dragndrop.moved_row_prev_index=moved_row.TrLineNr;

  // Drag&Drop
  if ((moved_row_parent.update_row_hooks == dragndrop.update_symtable_row_hooks)
  ||  (moved_row_parent.nbElements > 1)) {
    // There's no point in moving or erasing the last line of the listing
    // (or else we won't be able to recreate the others)
    dragndrop.moved_row_prevSibling=moved_row.previousSibling;  // there is ALWAYS a previous sibling (the header or colgroups)
    moved_row.className="selected";  // highlight / change the display style

    // move action
    dragndrop.dragdropstate = 1; // default, listing
    if (moved_row_parent.update_row_hooks == dragndrop.update_symtable_row_hooks) {
      dragndrop.dragdropstate = 2;
    }
    document.onmouseup=dragndrop.mouse_drop_row;
    document.onmousemove=ygwm.autoScroll;
    document.body.style.cursor='move';
  }
  return false;
},
*/

/////////////////////////////////////////////////

  start_move: function(ev){
  // anti-window-manager-hickup :
    if (document.onmouseup)
      document.onmouseup(ev);

    // display the trash bin only if clicking on certain elements :
    if (this.dnd.trashBin==true) {
      // load the trash bin image (on demand)
      if (!dragndrop.trash_div_id) {
        var tr =(dragndrop.transport_div =document.createElement("DIV")),
            div=(dragndrop.trash_div_id  =document.createElement("DIV")),
            fr =(dragndrop.trash_frame_id=document.createElement("DIV")),
            msg=(dragndrop.message_id    =document.createElement("DIV")),
            img=(dragndrop.trash_image_id=document.createElement("IMG"));
        div.id="trash_div";
        fr.id="trash_frame";
        img.id="trash_image";
        msg.id="trash_msg";

        // configure and install the trash image callbacks
         tr.style.zIndex=
        div.style.zIndex=ygwm.noScrollIndex;
        img.onmouseover=dragndrop.trash_mouseover;
        img.onmouseout= dragndrop.trash_mouseout;

          img.src="img/trash.png";
          fr.appendChild(img);
        div.appendChild(fr);

        div.appendChild(msg);

        document.body.appendChild(div);
  
          tr.id="transport";
        document.body.appendChild(tr);
      }
      dragndrop.trash_message("happy");
      dragndrop.trash_div_id.style.top=(5+menu.mainMenu_id.scrollHeight)+"px";
      dragndrop.trash_div_id.style.display="block";
    }

    /////// ok here it gets serious
    dragndrop.selected=this;
    ygwm.moved_div=
    dragndrop.moved_item=this.dnd.root;    // get the clicked item's id
    dragndrop.dragdropstate = this.dnd.state;
    document.onmouseup=dragndrop.end_move;
    document.onmousemove=ygwm.autoScroll;
    document.body.style.cursor='move';
    if (typeof this.dnd.ondrag=="function")
      this.dnd.ondrag(this.dnd.root);
    return false;
  },


  end_move: function(){
    var m=dragndrop.selected;
    if (dragndrop.trash_open)
      m.dnd.ondelete();
    else
      if (typeof dragndrop.ondrop=="function")
        dragndrop.ondrop(); // move

// Cleanup :
    dragndrop.dragdropstate = 0;

//  done in the callback of trash_message() :
//    dragndrop.trash_div_id.style.display="none";
    if (dragndrop.trash_div_id // check that the trash is created AND shown (could be prevented by trashBin=false)
         && dragndrop.trash_div_id.style.display=="block")
      dragndrop.trash_mouseout();

    document.onmouseup=null;
    document.onmousemove=null;
    document.body.style.cursor='auto';

    ygwm.moved_div=
    dragndrop.moved_item=
    dragndrop.ondrop=
    dragndrop.destination=null;
    return false;
  },

  // register an item that will be moved
  register: function(div, args){
    div.onmousedown=dragndrop.start_move;
    if (typeof args.state != "number")
      args.state=0;
    if (typeof args.trashBin != "boolean") {
      args.trashBin=false;
      if (typeof args.ondelete != "function")
        alert("registering a trashBin\nrequires ondelete()\nclassName="+div.className);
    }
    if (typeof args.root == "undefined")
      args.root=div;
    div.dnd=args;
  },

  // The destination items just need to define the dragndrop.ondrop function.

  init_obj: function(){
// init dragndrop.happy_messages with cookies
  }
});
